#ifndef __SAMPLE_DLG_H__
#define __SAMPLE_DLG_H__

#include "DataManager.h"
#include "TransferManager.h"

INT_PTR CALLBACK SampleDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

class SampleDlg
{
public:
	SampleDlg(HINSTANCE hInstance, DataManager *pDataManager);
	virtual ~SampleDlg(void);

private:
	HWND			m_hDlg;
	HINSTANCE		m_hInstance;
	DataManager		*m_pDataManager;
	TransferManager	*m_pTransferManager;
	int				m_nImageNum;
	LONG			m_nImageWidthFront;
	LONG			m_nImageHeightFront;
	LONG			m_nImageWidthRear;
	LONG			m_nImageHeightRear;
	HDC				m_hDCFront;
	HDC				m_hDCRear;
	HBITMAP			m_hbmFront;
	HBITMAP			m_hbmRear;
	TW_BOOL			m_bShowUI;

public:
	BOOL		OnInitDialog			(HWND hDlg);
	void		OnPaint					(void);
	void		OnBtnAcquire			(void);
	void		ChangeState				(STATECODE	status);
	void		Update					(void);
	HWND		GetDlgHandle			(void){return m_hDlg;}
	void		ScanFinish				(void);
	void		OnBtnUIModeChange		(void);
	void		OnBtnSelectSource		(void);
	void		OnBtnSettings			(HWND hDlg);
	void		SetTransferManager		(TransferManager *pTransferManager);
	TW_BOOL		GetbShowUI()
				{
					return m_bShowUI;
				}
	void		UpdateSourceTxt			(LPCTSTR lpSourceName);
	HWND		GetHWND() 
				{
					return m_hDlg;
				}

private:
	BOOL		UpdateMicrData			(void);
	BOOL		UpdateOcrData			(void);
	BOOL		UpdateBarcodeData		(void);
	BOOL		UpdateView				(void);
	BOOL		InitView				(BOOL bFirst=FALSE);
	BOOL		InitViewSub				(TW_UINT32 targetView, BOOL bFirst=FALSE);
	BOOL		InitRecog				(BOOL bFirst=FALSE);
	BOOL		GetBarcodeTypeString	(TW_UINT32 Type, TW_STR255* pStr);
	void		SettingsButtonUpdate	(void);
	HBITMAP		FixUp					(HWND, HANDLE);
	WORD		DibNumColors			(VOID FAR *);

};

#endif	// __SAMPLE_APP_H__
